//*************************************************************
//	   Java application
//			uFileChooserTestv
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOOV^PQ
//@@@@@@@@@@ŏIXVFQOOV^PQ    [TN118/J108]
//*************************************************************
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;

public class FileChooserTest extends JPanel implements ActionListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;

	public static void main(String[] args) {
		JFrame frame=new JFrame();
		frame.getContentPane().add(new FileChooserTest());
		frame.setTitle("FileChooserTest");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//E~ŏI
		frame.setSize(650,250);
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//
	File file;
	File[] files;
	//
	JCheckBox checkBeforeFile=new JCheckBox("OpXgp");
	JTextField textPath=new JTextField(20);
	JComboBox comboChooserType=new JComboBox(new String[]{"OpenDialog","SaveDialog","Dialog"});
	JComboBox comboSelectMode=new JComboBox(new String[]{"FILES_ONLY","DIRECTORIES_ONLY","FILES_AND_DIRECTORIES"});
	JTextField textTitle=new JTextField(8);
	JTextField textButton=new JTextField(8);
	JTextField textToolTip=new JTextField(8);
	JCheckBox checkAddFilter=new JCheckBox("VtB^[ǉ");
	JCheckBox checkHideFilter=new JCheckBox("{tB^[폜");
	JCheckBox checkMulti=new JCheckBox("I\");
	JCheckBox checkHideFile=new JCheckBox("Bt@C\");
	JButton buttonShowChooser=new JButton("\");
	JLabel labelResultFile=new JLabel("I");
	JLabel labelResultName=new JLabel("I");
	//
	public FileChooserTest(){
		//
		file=null;
		files=null;
		//
		add(checkBeforeFile);
		add(new JLabel("@pXwF"));
		add(textPath);
		add(new JLabel("@^CvF"));
		add(comboChooserType);
		add(new JLabel("@^CgF"));
		add(textTitle);
		add(new JLabel("@{^F"));
		add(textButton);
		add(new JLabel("@{^c[`bvF"));
		add(textToolTip);
		add(new JLabel("@I[hF"));
		add(comboSelectMode);
		add(checkAddFilter);
		add(checkHideFilter);
		add(checkMulti);
		add(checkHideFile);
		add(buttonShowChooser);
		add(new JLabel(" DIR : "));
		add(labelResultFile);
		add(new JLabel(" NAME : "));
		add(labelResultName);
		//
		buttonShowChooser.addActionListener(this);
	}
	//
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonShowChooser){
			//
			JFileChooser chooser;
			//KvȂpXw肵āAIuWFNg쐬
			if(checkBeforeFile.isSelected()){
				if(!checkMulti.isSelected()){	//PƑI
					chooser=new JFileChooser(file);
				}else{							//I\
					chooser=new JFileChooser();
					chooser.setSelectedFiles(files);
				}
			}else{
				if(!textPath.getText().equals("")){
					chooser=new JFileChooser(textPath.getText());
				}else{
					chooser=new JFileChooser();
				}
			}
			//_CAÕ^Cg
			if(!textTitle.getText().equals("")){
				chooser.setDialogTitle(textTitle.getText());
			}
			//OK{^̕
			if(!textButton.getText().equals("")){
				chooser.setApproveButtonText(textButton.getText());
			}
			//OK{^̃c[`bv
			if(!textToolTip.getText().equals("")){
				chooser.setApproveButtonToolTipText(textToolTip.getText());
			}
			//t@CƃtH_[AǂIׂ邩
			switch(comboSelectMode.getSelectedIndex()){
			case 0:
				//chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);	//l
				break;
			case 1:
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				break;
			case 2:
				chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
				break;
			}
			//VtB^[ǉ
			if(checkAddFilter.isSelected()){
				chooser.addChoosableFileFilter(new TextFilter());
				//Vo[WȂȉ̊ȒPȕ@łł炵
				//FileFilter filter=new FileNameExtensionFilter("eLXgt@C","txt");
				//chooser.addChoosableFileFilter(filter);
			}
			//{́uׂĂ\vtB^[\Ȃ
			if(checkHideFilter.isSelected()){
				chooser.setAcceptAllFileFilterUsed(false);
			}
			//I\
			if(checkMulti.isSelected()){
				chooser.setMultiSelectionEnabled(true);
			}
			//Bt@C\
			if(checkHideFile.isSelected()){
				chooser.setFileHidingEnabled(false);
			}
			//Z[u[hAČʂ󂯎
			int ret=0;
			if(comboChooserType.getSelectedIndex()==0){
				ret=chooser.showOpenDialog(this);
			}else if(comboChooserType.getSelectedIndex()==1){
				ret=chooser.showSaveDialog(this);
			}else if(comboChooserType.getSelectedIndex()==2){
				ret=chooser.showDialog(this,"wł");
			}
			//t@CǏʂ\
			switch(ret){
			case JFileChooser.APPROVE_OPTION:
				if(!checkMulti.isSelected()){				//PƑI
					file=chooser.getSelectedFile();
					labelResultFile.setText(getDir(file));			//fBNg
					labelResultName.setText(file.getName());		//t@C
				}else{										//I\
					files=chooser.getSelectedFiles();			//zŎ󂯎
					//
					StringBuffer bufName=new StringBuffer();
					for(int f=0;f<files.length;f++){
						bufName.append(files[f].getName()+" , ");
					}
					bufName.delete(bufName.length()-3,bufName.length());
					labelResultFile.setText(getDir(files[0]));		//ʃfBNg
					labelResultName.setText(bufName.toString());	//t@CL
				}
				break;
			case JFileChooser.CANCEL_OPTION:
				labelResultFile.setText("LZ܂");
				labelResultName.setText("LZ܂");
				break;
			case JFileChooser.ERROR_OPTION:
				labelResultFile.setText("G[͎܂");
				labelResultName.setText("G[͎܂");
				break;
			}
		}
	}
	//t@CÕfBNg܂ł𔲂o
	private String getDir(File f){
		String path=f.toString();
		return path.substring(0, path.length()-f.getName().length());
	}
	//------------------------------------------------------------------------
	//eLXgt@CIяoAFileFilter̃TuNX
	class TextFilter extends FileFilter{
		//\邩̔I[o[Ch
		public boolean accept(File f) {
			//fBNgȂ\
			if(f.isDirectory()){
				return true;
			}
			//gq𓾂
			String ext="";
			String name=f.getName();
			int index=name.lastIndexOf(".");
			if(index>0 && index<name.length()-1){
				ext=name.substring(name.lastIndexOf(".")+1).toLowerCase();
			}
			//eLXgt@CȂ\
			if(ext.equals("txt")){
				return true;
			}else{
				return false;
			}
		}
		//I[o[Ch
		public String getDescription() {
			return "eLXgt@Ci*.txtj";
		}
	}

}
